import tarfile
import re
import glob

linux_kmod_versions = [[327, 272],[514, 272],[642, 272],[693, 287],[862, 306]] #fill as [linux_minor_ver, kmod_ver]
Source_Directory = 'C:/Program Files (x86)/Symantec/Data Center Security Server/Server/logfiles/*/*/*.gz'
kmod_reg = '(sdcss-kmod)-(\d.\d.\d)-(\d{3}).(\w+\d.\w\d+_\d+)' #symantec k-mod version parsing. [0] - "sdcss-kmod", [1] - agent version, [2] - kmod version
linux_reg = '(Linux)\s([a-zA-Z].*)\s(\d.\d+.\d)-(\d+).(.*)' #linux kernel version parsing [0] - "Linux", [1] - server name, [2] - major kernel version, [3] - minor kernel version 
file_name = './sysinfo.txt' #file in .gz archive to be parsing

for file in glob.iglob(Source_Directory, recursive=True):
	tar = tarfile.open(file, "r:gz")
	e = tar.extractfile(tar.getmember(file_name))
	content=e.read().decode('utf-8')
	kmod_data_parsed=re.findall(kmod_reg,content)
	linux_data_parsed=re.findall(linux_reg,content)
	if kmod_data_parsed and linux_data_parsed: #check that symantec agent version and Linux Kernel parsing ok
		if linux_data_parsed[0][0] == 'Linux': #check that OS is Linux
			for i, z in enumerate(linux_kmod_versions):
				if int(linux_data_parsed[0][3]) == int(z[0]):
					if int(linux_kmod_versions[i][1]) >= int(kmod_data_parsed[0][2]):
						print("Kernel verions for", linux_data_parsed[0][1], "compatible with agent kmod verion", kmod_data_parsed[0][2] )
					else:
						print("Kernel verions for", linux_data_parsed[0][1], "is not compatible with agent kmod verion", kmod_data_parsed[0][2] )
	else:
		print("error parsing file")
